/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : gVector.h                                                */
/*                                                                       */
/*       Date : July , 1997                                              */
/* Updated at : November 14, 1997                                        */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _GVECTOR_H
#define _GVECTOR_H

#include <iostream.h>
#include <stdio.h>
#include <deffunc.h>

template<class T1>
class gVector
{  public :

     gVector();
     gVector(unsigned _capacity);
     gVector(const gVector<T1>&);
     ~gVector();

       //* Adds the given object
     addElement(T1 _newElement);

       //* Adds the given object
     addElementFront(T1 _newElement);

       //* Gets the pointer of indexed objec.
     T1 *getElement(unsigned index) const;

       //* Gets the pointer of first object.
     T1 *getFirstElement() const { return getElement(0); } ;

       //* Gets the pointer of first object.
     T1 *getLastElement() const { return (index?getElement(index-1):NULL); } ;

       //* Gets the pointer of first object.
     T1 *getNthElement(unsigned indx) const { return getElement(indx); } ;

       //* Removes the given object from the Vector
     removeElement(T1);

       //* Removes the given indexed object from the Vector
     removeElementAt(unsigned index);

     void swap(int indx1, int indx2);

     gVector<T1> operator=(const gVector<T1>&);

     operator==(const gVector<T1>&);

     void printMe(ostream&) const;

     unsigned getSize() const;

     friend ostream & operator<<(ostream& os ,const gVector<T1>& RHS)
     {
	RHS.printMe(os);
	return os;
     };


   private:

                T1  *data;
          unsigned  capacity;
          unsigned  currentCapacity;
	  unsigned  index;
	  float     gRate;

   protected:

     void dispose();
     void copyFrom(const gVector<T1>&);
     void adjustTo(unsigned);

}; // end of class gVector

#endif
